
//#include "metalShaderTypes.h"


vertex vertexOut vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& uniforms[[ buffer(3) ]])
{
    vertexOut out;

	out.normPos=in[vertexID].pos.xy;

	
	
	vec4 transOffset=vec4(0.,0.,1.0,.0);

	float stimer=0.;
	if(uniforms.transitionState==0)
	   stimer=3.1415926535897932384626433832795*1.5+uniforms.transitionProgress*.5*3.1415926535897932384626433832795;
	else if(uniforms.transitionState==2)
	   stimer=uniforms.transitionProgress*.5*3.1415926535897932384626433832795;

	mat4 rotation = mat4(
						 cos(stimer),  0.0,-sin(stimer), 0.0,
								0.0,  1.0,        0.0, 0.0,
						sin(stimer),  0.0, cos(stimer), 0.0,
								0.0,  0.0,        0.0, 1.0);
	mat4 projection = mat4(
						  2.4140,0.0000,0.0000,0.0000,
						  0.0000,2.4140,0.0000,0.0000,
						  0.0000,0.0000,-1.020,-.4870,
						  0.0000,0.0000,-1.000,0.0000);
	mat4 translation=mat4(
						   1.0, 0.0, 0.0, 0.00,
						   0.0, 1.0, 0.0, 0.00,
						   0.0, 0.0, 1.0,-2.42,
						   0.0, 0.0, 0.0, 1.00);
	mat4 scale=mat4(
						 1.0, 0.0, 0.0, 0.00,
						 0.0, 1.0, 0.0, 0.00,
						 0.0, 0.0, 1.0, 0.00,
						 0.0, 0.0, 0.0, 1.00);

	vec4 tmpPos=vec4(in[vertexID].pos.x,in[vertexID].pos.y,in[vertexID].pos.z,1.0)*uniforms.worldViewProj;

	vec4 worldPos=tmpPos*scale;
	worldPos+=transOffset;
	worldPos*=rotation;
	worldPos-=transOffset;
	worldPos*=translation;
//	gl_Position = worldPos*projection;
	out.position=worldPos*projection;
//	out.position=in[vertexID].pos*uniforms.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
    return out;
}

fragment float4 fragmentFunc(vertexOut in [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& u[[ buffer(2) ]])
{
	
	float4 outColor=tex(inputTex0,in.tex1);
#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,in.texMask).a);
#endif
	return outColor;
}
