#version 330

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform sampler2DRect maskTex;
uniform float transitionProgress=1.0;
uniform float transitionProgressLinear=1.0;
uniform float transitionAlpha=1.0;
uniform float baseAlpha=1.0;
uniform vec4 burnColor;

in vec2 fsTexture;
in vec2 fsTextureSize;
in vec2 fsMaskTexture;
in vec2 fsTextureNormalized;
in float fsABSelect;

out vec4 outColor;

float rand (vec2 co)
{
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

float Gaussian(float p, float center, float c)
{
    return 0.575 * exp(- pow((p - center) / c, 2.));
}

void main()
{
    vec2 p = fsTextureNormalized;
	
    float c = cos(Gaussian(transitionProgressLinear * (1. + Gaussian(transitionProgressLinear * rand(p), 0.5, 0.5)), 0.5, 0.5));
    vec2 d = p * c;
	
	vec4 texColor=texture(inputTex,d*fsTextureSize);
	vec4 colorA=mix(vec4(0,0,0,0),texColor,fsABSelect);
	vec4 colorB=mix(texColor,vec4(0,0,0,0),fsABSelect);

	outColor=mix(colorB,colorA,transitionProgressLinear);
#ifdef USE_MASK
	outColor.a*=texture(maskTex,fsMaskTexture).a;
#endif
}
